PROGRAM Demo;
{$X+,D-,S-,G+}
USES CRT, HiVGA6;

CONST Ver = '0.92';

TYPE String10 = STRING[10];

VAR XRes, YRes, PCXWriteCol: WORD;
    DelayTime: LONGINT;
    HiVGAPCX: POINTER;
    PCXLoaded: BOOLEAN;

PROCEDURE InitSleep;
VAR T: LONGINT ABSOLUTE $0:$46C;
    T1: LONGINT;
    c: CHAR;
BEGIN
  ClrScr;
  Write('Eine Sekunde Geduld bitte...');
  DelayTime := 0;
  WHILE KeyPressed DO c := ReadKey;
  T1 := T+18;
  WHILE (NOT KeyPressed) AND (T1>T) DO Inc(DelayTime);
END;

PROCEDURE Sleep(Sec: WORD);
VAR Over: BOOLEAN;
    c: CHAR;
    i: LONGINT;
BEGIN
  Over := FALSE;
  WHILE KeyPressed DO c := ReadKey;
  WHILE (Sec<>0) AND (NOT Over) DO BEGIN
    i := 0;
    WHILE (NOT KeyPressed) AND (i<DelayTime) DO Inc(i);
    IF KeyPressed THEN BEGIN
      c := ReadKey;
      Over := TRUE;
    END;
    Dec(Sec);
  END;
END;

PROCEDURE Delay(Time: WORD); ASSEMBLER;
ASM
           MOV  AX, 1000
           MOV  BX, Time
           MUL  BX
           MOV  CX, DX
           MOV  DX, AX
           MOV  AH, $86
           INT  $15
END;

FUNCTION Str(c: LONGINT): String10;
VAR s: String10;
    i: BYTE;
BEGIN
  i := 0;
  WHILE c>0 DO BEGIN
    s[10-i] := Char((c MOD 10)+48);
    c := c DIV 10;
    Inc(i);
  END;
  Move(s[10-i+1], s[1], i);
  s[0] := Char(i);
  Str := s;
END;

PROCEDURE CheckVGA;
VAR c: CHAR;
    ErrorCode: INTEGER;
BEGIN
  ErrorCode := VMode(V320x400); {320*400*256 mit zwei Bildschirmseiten!}
  IF ErrorCode<>ModeOK THEN BEGIN
    Write(#7);
    CASE ErrorCode OF
      NoVGA:        WriteLn('HiVGA luft nur auf VGA-Karten!');
      FalseMode:    WriteLn('Falsche Modusnummer!');
      OnlyTTL:      WriteLn('Es ist nur ein TTL-Monitor angeschlossen!');
      NotSupported: WriteLn('Modus wird von der VGA-Karte nicht untersttzt!');
      NotKnown:     WriteLn('SVGA-Karte nicht erkannt, Modus konnte'+
                            'nicht eingeschaltet werden!');
    END;
    WriteLn('Das Programm wurde abgebrochen!');
    Write('Bitte eine Taste drcken...');
    WHILE NOT KeyPressed DO;
    c := ReadKey;
    Halt(1);
  END;
  XRes := VMode(GetXRes); YRes := VMode(GetYRes);
END;

PROCEDURE StartScreen;
VAR i: INTEGER;
    r, g, b: BYTE;
BEGIN
  CLG(Black);
  FOR i := 0 TO 15 DO BEGIN
    ReadCol(i, r, g, b);
    MakeCol(i+16, r, g, b);
    MakeCol(i+32, r, g, b);
  END;
  ScrOnOff(FALSE);
  FOR i := 1 TO 30 DO Box(40-i, 90-i, 279+i, 259+i, i+15);
  Bar(40, 90, 279, 259, LightCyan);
  TxtStyle(SFont8x16, 2, 3, 1);
  PlotTxt(60, 105, Blue, 'HiVGA V '+Ver);
  TxtStyle(SFont8x14, 1, 2, 1);
  PlotTxt(52, 150, Blue, 'fr Turbo Pascal 6.0/7.0');
  TxtStyle(SFont8x16, 1, 1, 0);
  PLotTxt(124, 184, LightBlue, 'c');
  SCircle(127, 192, 5, LightBlue);
  PlotTxt(132, 185, LightBlue, ' 1994 by');
  PlotTxt(96, 205, LightBlue,'Matthus Stadler');
  PlotTxt(100, 225, LightBlue,'Manuel Richardt');
  TxtStyle(SFont8x8, 1, 1, 0);
  MakeCol(48, 0, 0, 0); MakeCol(49, 0, 0, 0);
  Bar(0, 330, 319, 349, 48);
  PlotTxt(52, 338, 49, '256 Farben fr Turbo Pascal!');
  ScrOnOff(TRUE);
  Sleep(3);
  FOR i := 30 DOWNTO 0 DO BEGIN
    MakeCol(i+16, 0, 0, i+10);
    MakeCol(48, 60-2*i, 60-2*i, 0);
    MakeCol(49, 60-2*i, 0, 0);
    Delay(35);
  END;
  FOR i := 52 DOWNTO 0 DO BEGIN
    WVRetrace;
    Bar(i, 338, i+222, 344, 48);
    PlotTxt(i, 338, 49, '256 Farben fr Turbo Pascal!');
  END;
  FOR i := 959 DOWNTO 372 DO BEGIN
    WVRetrace;
    Bar(i, 335, i+222, 341, 48);
    PlotTxt(i, 335, 49, '256 Farben fr Turbo Pascal!');
  END;
  GetCol;
  Sleep(4);
  Bar(0, 330, 319, 349, Black);
END;

PROCEDURE HiVGAInfo;
CONST InfoLen = 23;
Info: ARRAY[1..InfoLen] OF STRING[38] =
(('HiVGA ist eine Turbo Pascal 6.0 / 7.0-'),
 ('Unit fr die Untersttzung von Grafik-'),
 ('routinen  mit 256 Farben  auf VGA- und'),
 ('SVGA-Karten  ohne  den Einsatz zustz-'),
 ('licher Treiber oder BGIs.             '),
 ('Untersttzt werden diese Auflsungen: '),
 (''),
 ('- Standard-VGA-Karten:  320x200 (1 / 4'),
 ('  Seiten), 320x400/2 Seiten, 360x480; '),
 ('- Viele SVGA-Karten: 640x350, 640x400,'),
 ('  640x480, 800x600, 1024x768.         '),
 ('- VESA-VGA-Karten sogar bis 1280x1024!'),
 (''),
 ('Angeboten werden Zeichenbefehle, Farb-'),
 ('palettenmanipulation,  Scrolling, PCX-'),
 ('Loader...;                            '),
 (''),
 ('Weitere Versionen von HiVGA erscheinen'),
 ('noch 1994.                            '),
 (''),
 (''),
 ('** HiVGA ist auch  in einer Version **'),
 ('** fr  Power Basic 3.0 erhltlich! **'));
VAR i, j, k, Len: BYTE;
    x, y: WORD;
BEGIN
  MakeCol(50, 0, 10, 0); MakeCol(51, 0, 40, 0); MakeCol(52, 0, 63, 0);
  SetPage(1);
  CLG(50);
  Box(0, 0, XRes-1, YRes-1, 52);
  Box(2, 2, XRes-3, YRes-3, 52);
  ShowPage(1);
  TxtStyle(SFont8x16, 1, 1, 0);
  y := 8;
  FOR i := 1 TO InfoLen DO BEGIN
    j := 1; Len := Length(Info[i]);
    x := 8;
    WHILE j<=Len DO BEGIN
      IF Info[i][j]<='Z' THEN k := 32
                         ELSE k := 91;
      PlotTxt(x, y+2, 52, '_');
      WHILE Chr(k)<>Info[i][j] DO BEGIN
        PlotTxt(x, y, 52, Chr(k));
        Delay(3);
        PlotTxt(x, y, 50, Chr(k));
        Inc(k);
      END;
      PlotTxt(x, y+2, 50, '_');
      PlotTxt(x, y, 51, Info[i][j]);
      Inc(x, 8);
      Inc(j);
    END;
    Inc(y, 16);
  END;
  Sleep(10);
END;

PROCEDURE GraphDemo;
CONST Wx: WORD = 150; Wy: WORD = 150;
TYPE Win = RECORD
             x, y : WORD;
           END;
VAR W: ARRAY[1..4] OF Win;
    ra, rb, rr, rx, rx1, rx2, ry, ry1, ry2: WORD;
    i: INTEGER;
BEGIN
  WITH W[1] DO BEGIN x :=   4; y :=  59; END;
  WITH W[2] DO BEGIN x := 165; y :=  59; END;
  WITH W[3] DO BEGIN x :=   4; y := 239; END;
  WITH W[4] DO BEGIN x := 165; y := 239; END;
  Randomize;
  SetPage(1);
  CLG(Black);
  RestorePal;
  ShowPage(1);
  TxtStyle(SFont8x16, 1, 2, 0);
  PlotTxt(0, 0, LightMagenta, 'HiVGA kennt folgende Zeichenbefehle:');
  FOR i := 1 TO 4 DO WITH W[i] DO Box(x, y, x+Wx, y+Wx, LightCyan);
  TxtStyle(SFont8x8, 1, 1, 0);
  Sleep(2);
  WITH W[1] DO BEGIN
    PlotTxt(x, y-10, LightMagenta, 'Einzelne Punkte');
    PlotTxt(x, y+Wy+3, LightMagenta, '5000 * "SetPix"');
    Sleep(2);
    FOR i := 1 TO 5000 DO BEGIN
      rx := x+1+Random(Wx-1);
      ry := y+1+Random(Wy-1);
      SetPix(rx, ry, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[2] DO BEGIN
    PlotTxt(x, y-10, LightMagenta, 'Linien');
    PlotTxt(x, y+Wy+3, LightMagenta, '1000 * "XYLine"');
    Sleep(2);
    FOR i := 1 TO 1000 DO BEGIN
      rx1 := x+1+Random(Wx-1);
      ry1 := y+1+Random(Wy-1);
      rx2 := x+1+Random(Wx-1);
      ry2 := y+1+Random(Wy-1);
      XYLine(rx1, ry1, rx2, ry2, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[3] DO BEGIN
    PlotTxt(x, y-10, LightMagenta, 'Rechtecke');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "Box"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx1 := x+1+Random(Wx-1);
      ry1 := y+1+Random(Wy-1);
      rx2 := x+1+Random(Wx-1);
      ry2 := y+1+Random(Wy-1);
      Box(rx1, ry1, rx2, ry2, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[4] DO BEGIN
    PlotTxt(x, y-10, LightMagenta, 'Gefllte Rechtecke');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "Bar"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx1 := x+1+Random(Wx-1);
      ry1 := y+1+Random(Wy-1);
      rx2 := x+1+Random(Wx-1);
      ry2 := y+1+Random(Wy-1);
      Bar(rx1, ry1, rx2, ry2, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[1] DO BEGIN
    Bar(x, y-10, x+Wx, y-3, Black);
    Bar(x, y+Wy+3, x+Wx, y+Wy+10, Black);
    Bar(x+1, y+1, x+Wx-1, y+Wy-1, Black);
    PlotTxt(x, y-10, LightMagenta, 'Kreise');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "SCircle"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx := x+25+Random(Wx-49);
      ry := y+25+Random(Wy-49);
      rr := 5+Random(20);
      SCircle(rx, ry, rr, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[2] DO BEGIN
    Bar(x, y-10, x+Wx, y-3, Black);
    Bar(x, y+Wy+3, x+Wx, y+Wy+10, Black);
    Bar(x+1, y+1, x+Wx-1, y+Wy-1, Black);
    PlotTxt(x, y-10, LightMagenta, 'Gefllte Kreise');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "FCircle"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx := x+25+Random(Wx-49);
      ry := y+25+Random(Wy-49);
      rr := 5+Random(20);
      FCircle(rx, ry, rr, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[3] DO BEGIN
    Bar(x, y-10, x+Wx, y-3, Black);
    Bar(x, y+Wy+3, x+Wx, y+Wy+10, Black);
    Bar(x+1, y+1, x+Wx-1, y+Wy-1, Black);
    PlotTxt(x, y-10, LightMagenta, 'Ellipsen');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "SEllipse"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx := x+30+Random(Wx-59);
      ry := y+30+Random(Wy-59);
      ra := 4+Random(20);
      rb := 4+Random(20);
      SEllipse(rx, ry, ra, rb, Random(240));
    END;
  END;
  Sleep(3);
  WITH W[4] DO BEGIN
    Bar(x, y-10, x+Wx, y-3, Black);
    Bar(x, y+Wy+3, x+Wx, y+Wy+10, Black);
    Bar(x+1, y+1, x+Wx-1, y+Wy-1, Black);
    PlotTxt(x, y-10, LightMagenta, 'Gefllte Ellipsen');
    PlotTxt(x, y+Wy+3, LightMagenta, '500 * "FEllipse"');
    Sleep(2);
    FOR i := 1 TO 500 DO BEGIN
      rx := x+30+Random(Wx-59);
      ry := y+30+Random(Wy-59);
      ra := 4+Random(20);
      rb := 4+Random(20);
      FEllipse(rx, ry, ra, rb, Random(240));
    END;
  END;
  Sleep(3);
  PlotTxt(0, 31, LightMagenta, 'Linien ziehen mit "LineTo":');
  Sleep(2);
  i := 0;
  MoveTo(0, 39);
  WHILE i < 311 DO BEGIN
    Inc(i, 10); LineTo(i, 44, LightCyan); Delay(250);
    Inc(i, 10); LineTo(i, 39, LightCyan); Delay(250);
  END;
  Bar(0, 31, 215, 38, Black);
  Sleep(3);
  PlotTxt(0, 31, LightMagenta, 'Bereiche fllen mit "Fill":');
  Sleep(2);
  Fill(160, 199, Cyan, LightCyan);
  Sleep(8);
  CLG(Black);
END;

PROCEDURE FuersAuge;
VAR i: INTEGER;
    r, g, b: BYTE;
BEGIN
  SetCol(0,255);
  SetPage(0);
  ShowPage(0);
  FOR i := 1 TO 32 DO BEGIN
    MakeCol(i+50, i-1, 0, 0);
    MakeCol(i+82, 32-i, i-1, 0);
    MakeCol(147-i, 0, i-1, 0);
  END;
  GetCol;
  Box(30, 400, 290, 620, LightCyan);
  FOR i := 96 DOWNTO 1 DO FCircle(160, 512, i, i+50);
  Sleep(3);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(80, 310, LightMagenta, 'Palettenmanipulation');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(104, 360, LightMagenta, 'mit "CycleCol"');
  Sleep(2);
  FOR i := 0 TO 295 DO BEGIN
    WVRetrace;
    GScroll(0, i);
  END;
  Sleep(1);
  GetPal;
  FOR i := 1 TO 384 DO BEGIN
    WVRetrace;
    CycleCol(51, 146, 1);
  END;
  FOR i := 1 TO 384 DO BEGIN
    WVRetrace;
    CycleCol(51, 146, 0);
  END;
  Sleep(1);
  Bar(80, 310, 240, 376, Black);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(44, 630, LightMagenta, 'Farben in Graustufen umsetzen');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(108, 680, LightMagenta, 'mit "SetGrey"');
  Sleep(1);
  GetCol;
  FOR i := 1 TO 96 DO BEGIN
    WVRetrace;
    SetGrey(51, i);
  END;
  Sleep(1);
  Bar(44, 630, 276, 696, Black);
  Sleep(1);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(52, 630, LightMagenta, 'Palette wieder restaurieren');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(112, 680, LightMagenta, 'mit "SetCol"');
  Sleep(2);
  SetCol(51,146);
  Sleep(2);
  FOR i := 295 DOWNTO 0 DO BEGIN
    WVRetrace;
    GScroll(0, i);
  END;
  Sleep(2);
  Bar(40, 630, 280, 696, Black);
  ReadCol(LightMagenta, r, g, b);
  MakeCol(255, r, g, b);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(52, 310, 255, 'Bildschirminhalt    blenden');
  PlotTxt(188, 310, LightMagenta, 'aus');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(120, 360, 255, 'mit "Fade"');
  Sleep(2);
  FOR i := 255 DOWNTO 0 DO BEGIN
    WVRetrace;
    Fade(i, 1, 49);
    Delay(25);
  END;
  Sleep(1);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(188, 310, Black, '');
  PlotTxt(188, 310, LightMagenta, 'ein');
  Sleep(1);
  FOR i := 0 TO 255 DO BEGIN
    WVRetrace;
    Fade(i, 1, 49);
    Delay(25);
  END;
  Sleep(5);
  Bar(52, 310, 268, 376, Black);
END;

PROCEDURE ScrollDemo;
VAR i: INTEGER;
BEGIN
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(40, 0, LightMagenta, 'Bildschirm teilen und scrollen');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(48, 40, LightMagenta, 'mit "SplitScr" und "GScroll"');
  SplitScr(339);
  FOR i := 0 TO 2*XRes DO BEGIN
    WDisplay;
    GScroll(i, 0);
    IF (VMode(IsPlanar)=1) THEN BEGIN
      SplitPixPan;
      PixPan(i MOD 8);
    END;
  END;
  FOR i := 2*XRes DOWNTO 0 DO BEGIN
    WDisplay;
    GScroll(i, 0);
    IF (VMode(Isplanar)=1) THEN BEGIN
      SplitPixPan;
      PixPan(i MOD 8);
    END;
  END;
  FOR i := 0 TO YRes DO BEGIN
    WVRetrace;
    GScroll(0, i);
  END;
  FOR i := YRes DOWNTO 0 DO BEGIN
    WVRetrace;
    GScroll(0, i);
  END;
  Sleep(3);
  Bar(40, 0, 280, 56, Black);
  SplitScr(399);
END;

PROCEDURE PCXDemo;
CONST x1 = 127;
      y1 = 134;
      x2 = 193;
      y2 = 170;
      cx = 160;
      cy = 1;
VAR i, j, k: INTEGER;
    BufO, BufM: POINTER;
BEGIN
  SetPage(1);
  CLG(Black);
  WVRetrace; ShowPage(1);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(52, 300, LightMagenta, '256 Farben-PCX-Bilder laden');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(108, 350, LightMagenta, 'mit "PCXLoad"');
  Sleep(2);
  GetPal;
  Bar(52, 300, 268, 366, Black);
  PCXLoaded := FALSE;
  IF LoadPCX('HiVGA.PCX', 0, 0)<>PCXOK THEN BEGIN
    TxtStyle(SFont8x16, 1, 3, 0);
    PlotTxt(32, 190, Red, 'Fehler beim Laden von HIVGA.PCX!');
    PCXWriteCol := Red;
    Sleep(6);
    Exit;
  END;
  PCXLoaded := TRUE;
  GetMem(HiVGAPCX, GetSize(0, 0, 319, 199));
  GetImg(0, 0, 319, 199, HiVGAPCX^);
  GetCol;
  Sleep(3);
  PCXWriteCol := GetPix(cx, cy);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(64, 300, PCXWriteCol, 'Bildausschnitte kopieren');
  TxtStyle(SFont8x16, 1, 1, 0);
  PlotTxt(72, 350, PCXWriteCol, 'mit "GetImg", "SetImg"');
  Sleep(2);
  GetMem(BufO, GetSize(x1, y1, x2, y2));
  GetMem(BufM, GetSize(x1, y1, x2, y2));
  GetImg(x1, y1, x2, y2, BufO^);
  FOR i := x1 TO x2 DO BEGIN SetPix(i, y1, Black); Delay(40); END;
  FOR i := y1 TO y2 DO BEGIN SetPix(x2, i, Black); Delay(40); END;
  FOR i := x2 DOWNTO x1 DO BEGIN SetPix(i, y2, Black); Delay(40); END;
  FOR i := y2 DOWNTO y1 DO BEGIN SetPix(x1, i, Black); Delay(40); END;
  GetImg(x1, y1, x2, y2, BufM^);
  Bar(x1, y1, x2, y2, Black);
  FOR i := 1 TO 100 DO SetImg(Random(300), 200+Random(200), BufM^);
  Sleep(2);
  SetImg(x1, y1, BufO^);
  FreeMem(BufO, GetSize(x1, y1, x2, y2));
  FreeMem(BufM, GetSize(x1, y1, x2, y2));
  Sleep(5);
  CLG(Black);
  SetPal;
END;

PROCEDURE Try640x480;
VAR i, Disp, ErrorCode: INTEGER;
BEGIN
  SetPage(1);
  CLG(Red);
  TxtStyle(SFont8x16, 1, 2, 0);
  PlotTxt(60, 180, Blue, 'Es wird nun versucht, den');
  PlotTxt(32, 220, Blue, '640*480 SVGA-Modus einzuschalten');
  ShowPage(1);
  Delay(4000);
  ErrorCode := VMode(S640x480);
  IF ErrorCode<>0 THEN BEGIN
    VMode(V320x400);
    CLG(Blue);
    CASE ErrorCode OF
      NotSupported: BEGIN
        PlotTxt(48, 180, Red, 'Modus wird von der VGA-Karte');
        PlotTxt(88, 220, Red, 'nicht untersttzt!');
      END;
      NotKnown: BEGIN
        PlotTxt(64, 180, Red, 'VGA-Karte nicht erkannt!');
        PlotTxt(2, 220, Red, 'Bitte laden Sie einen VESA-Treiber.');
      END;
    END;
    Sleep(7);
    Exit;
  END;
  SetCol(0, 255);
  TxtStyle(SFont8x16, 1, 3, 0);
  PlotTxt(140, 10, PCXWriteCol, '640x480 SVGA-Modus erfolgreich eingeschaltet!');
  Sleep(2);
  IF PCXLoaded THEN BEGIN
    PlotTxt(224, 400, PCXWriteCol, 'Bildausschnitte kopieren');
    TxtStyle(SFont8x16, 1, 1, 0);
    PlotTxt(236, 450, PCXWriteCol, 'in andere Auflsungen');
    Sleep(2);
    SetImg(160, 140, HiVGAPCX^);
    FreeMem(HiVGAPCX, GetSize(0, 0, 319, 199));
  END ELSE BEGIN
    TxtStyle(SFont8x16, 1, 1, 0);
    PlotTxt(204, 220, PCXWriteCol, 'PCX-Bild wurde nicht geladen!');
    PlotTxt(152, 240, PCXWriteCol, 'Darum wird jetzt kein buntes Bild gezeigt!');
  END;
  Sleep(10);
  VMode(V320x400);
END;

PROCEDURE EndDemo;
CONST hx = 116;
      hy = 172;
VAR Col, i, x, y: WORD;
    c: CHAR;
BEGIN
  FOR i := 1 TO 63 DO MakeCol(i, 0, 0, i);
  FOR i := 64 TO 126 DO MakeCol(i, 0, 0, 127-i);
  Col := 1; y := 399;
  FOR x := 319 DOWNTO 95 DO BEGIN
    Box(320-x, 400-y, x, y, Col);
    Dec(y);
    Inc(Col); IF Col>126 THEN Col := 1;
  END;
  TxtStyle(SFont8x16, 2, 4, 2);
  MakeCol(255, 63, 63, 63);
  PlotTxt(hx, hy, 255, 'HiVGA');
  FOR y := hy TO hy+64 DO
    FOR x := hx TO hx+88 DO
      IF GetPix(x, y)=255 THEN SetPix(x, y, 1+Random(127));
  TxtStyle(SFont8x8, 1, 1, 0);
  PlotTxt(16, 390, 255, 'Taste drcken, um Demo zu beenden...');
  GetPal;
  WHILE KeyPressed DO c := ReadKey;
  WHILE NOT KeyPressed DO BEGIN
    WVRetrace;
    CycleCol(1,126,1);
  END;
END;

BEGIN
  InitSleep;
  CheckVGA;
  StartScreen;
  HiVGAInfo;
  GraphDemo;
  FuersAuge;
  ScrollDemo;
  PCXDemo;
  Try640x480;
  EndDemo;
  VMode(T80x25);
END.
